

                       {*********/ Componets/**********}
                       {*********/OX3DBEdit/***********}
                       {*****/Author:Nuri Erginer/****}
                       {***********/1998/*************}
                       {*/Ver 1.0/*Check by only Nuri*}


unit OX3DBEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls,DBGrids,db;

type
  TOX3DBEdit = class(TDBEdit)
  private
    MyDBGrid1: TDBGrid;
    FForm:TForm;
    FButton:TButton;
    FMyEdit:TEdit;
    FAuthor:string;
    FFocusColor:TColor;
    FButtonCaption:string;
    procedure OxLocate(var message:TMessage);message  WM_LBUTTONDBLCLK;
    procedure OxFocus(var Message: TMessage); message CM_ENTER;
    procedure OxNotFocus(var Message: TMessage); message CM_EXIT;
    procedure MyButtonClick(Sender: TObject);
    procedure MyChange(Sender: TObject);
    procedure MyEnter(Sender: TObject; var Key: Word;
  Shift: TShiftState);
    { Private declarations }
  protected
    { Protected declarations }
  public
    constructor Create (AOwner:Tcomponent);override;
    destructor Destroy;override;
    procedure SetAuthor(NewValue:string);

    { Public declarations }
  published
    property Author:string read FAuthor write SetAuthor;
    property FocusColor:TColor read FFocusColor write FFocusColor default clInfoBk;
    property ButtonCaption:String read FButtonCaption write FButtonCaption;

      { Published declarations }
  end;

procedure Register;

implementation
    var
    Renk:TColor;
    MyBookmark: TBookmark;
procedure Register;
begin
  RegisterComponents('MyComponents', [TOX3DBEdit]);
end;

constructor TOX3DBEdit.Create (AOwner:TComponent);
begin
   inherited;

    FAuthor:='Nuri Erginer e-mail:erginer@usa.net';
    FFocusColor:=clInfoBk;
    FButtonCaption:='Ok';
    end;

procedure TOX3DBEdit.SetAuthor(NewValue:string);
begin
   if NewValue <> 'Nuri Erginer e-mail:erginer@usa.net' then
    MessageDlg('Impossible To Change' ,mtError,[mbOk],0);
end;

procedure TOX3DBEdit.OxFocus(var message:TMessage);
begin
   Renk:=Self.Color;
   Self.Color:=FFocusColor;
end;

procedure TOX3DBEdit.OxNotFocus(var message:TMessage);
begin
   Self.Color:=Renk;
end;
procedure TOX3DBEdit.OxLocate(var message:TMessage);
var
i:SmallInt;
begin
MyBookmark:=self.DataSource.DataSet.GetBookmark;

            FForm:=TForm.Create(nil);
            FForm.Parent:=nil;
            FForm.Position:=poScreenCenter;
            FForm.BorderStyle:=bsDialog;
            FForm.BorderIcons:=[];
            FForm.Height:=250;
            FForm.Width:=500;

           FMyEdit:=TEdit.create(fform);
           FMyEdit.parent:=FForm;
           FMyEdit.left:=200;
           FMyEdit.top:=5;
           FMyEdit.OnChange:=MyChange;
           FMyEdit.OnKeyDown:=MyEnter;
            MyDBGrid1:=Tdbgrid.Create(FForm) ;
            MyDBGrid1.parent:=FForm;
            MyDBGrid1.readonly:=true;
            MyDBGrid1.Top:=30;
            MyDBGrid1.Height:=145;
            MyDBGrid1.Width:=492;
            MyDBGrid1.DataSource:=Self.DataSource;
            MyDBGrid1.Columns.State:=csCustomized;
            MyDBGrid1.Options:=MyDBGrid1.Options-[dgRowlines]+[dgRowSelect];

            FButton:=TButton.Create(FForm);
            FButton.parent:=FForm;
            FButton.Top:=182;
            FButton.Left:=220;
            FButton.Caption:=FButtonCaption;
            FButton.OnClick:=MyButtonClick;

            FForm.Visible:=True;
            FMyEdit.Visible:=True;

            //ilk yap
            for i:=0 to Self.DataSource.DataSet.FieldCount -1 do
               begin
                  if MyDBGrid1.Columns[i].FieldName= Self.DataField then
                    begin
                      MyDBGrid1.Columns[i].Index:=0;
                      MyDBGrid1.Columns[0].Color:=clInfoBk;
                    end;
               end;
            //son
            MyDBGrid1.Visible:=True;
end;

procedure TOX3DBEdit.MyButtonClick(Sender: TObject);
begin
FForm.Release;
end;

destructor TOX3DBEdit.Destroy;
begin
 inherited Destroy;
end;
procedure TOX3DBEdit.MyChange(Sender: TObject);
begin
try
self.DataSource.DataSet.Locate(self.DataField,FMyEdit.Text,[loCaseInsensitive, loPartialKey]);
except
abort;
end;
end;
procedure TOX3DBEdit.MyEnter(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then
FForm.Release;
if key=vk_escape then
begin
self.DataSource.DataSet.GotoBookmark(MyBookmark);
self.DataSource.DataSet.FreeBookmark(MyBookmark);
FForm.Release;
end;

end;
end.
